#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 100000
#define MAXM 500000

int n, m, c;
int v[MAXN];	/* Promichana cisla vrcholu */
int cn[MAXN];	/* Pocty vrcholu v komponentach 2-souvislosti */
int cbase[MAXN];	/* Pocty vrcholu v predchozich komponentach */
int rese[MAXM][2];	/* Vysledne pole s hranami */
int gene;

void connect_comp(int which, int where)
{
  rese[gene][0] = cbase[which]+random()%cn[which];
  rese[gene++][1] = cbase[where]+random()%cn[where];
}

void gencomp_edges(int comp, int edges)
{
  int e[edges][2];
  int i, j, a, b;

  /* Vygenerujeme kostru */
  for (i = 0; i < cn[comp]-1; i++) {
    a = random() % (i+1);
    if (random()%2) {
      e[i][0] = a;
      e[i][1] = i+1;
    }
    else {
      e[i][1] = a;
      e[i][0] = i+1;
    }
  }

  for (i = cn[comp]-1; i < edges; i++) {
regen:
    a = random() % cn[comp];
    b = random() % cn[comp];
    if (a == b)
      goto regen;
    for (j = 0; j < i; j++)
      if ((a == e[j][0] && b == e[j][1]) || (a == e[j][1] && b == e[j][0]))
        goto regen;
    e[i][0] = a;
    e[i][1] = b;
  }

  for (i = 0; i < edges; i++) {
    rese[gene][0] = cbase[comp]+e[i][0];
    rese[gene++][1] = cbase[comp]+e[i][1];
  }
}

void generate(void)
{
  int i, r, tmp;
  int genv = 0, ce = 0;

  /* Vygenerujeme velikosti komponent 2-souvislosti */
  for (i = 0; i < c-1; i++) {
    cbase[i] = genv;
    cn[i] = random() % (2*(n-genv)/(c-i)-1) + 1;
    fprintf(stderr, "Component size %d\n", cn[i]);
    genv += cn[i];
  }
  cbase[c-1] = genv;
  cn[c-1] = n-genv;

  /* Vygenerujeme precislovani vrcholu */
  for (i = 0; i < n; i++)
    v[i] = i;
  for (i = 0; i < n; i++) {
    r = random() % (n-i);
    tmp = v[i];
    v[i] = v[r];
    v[r] = tmp;
  }

  /* Vygenerujeme hrany mezi komponentami */
  for (i = 1; i < c; i++)
    connect_comp(i, random()%i);

  /* Vygenerujeme hrany v komponentach */
  for (i = 0; i < c; i++) {
    ce = ((long long)cn[i])*(m-gene)/(n-cbase[i]);
    if (ce < cn[i]-1)
      ce = cn[i]-1;
    if (ce > cn[i]*(cn[i]-1)/2)
      ce = cn[i]*(cn[i]-1)/2;
    fprintf(stderr, "Component %d: %d edges\n", i, ce);
    gencomp_edges(i, ce);
  }
}

void dump(void)
{
  int i, j;

  if (gene != m)
    fprintf(stderr, "Pozor! Pocet hran vysel %d\n", gene);
  printf("%d %d\n", n, gene);
  for (i = 0; i < gene; i++) {
    j = random() % (gene-i);
    printf("%d %d\n", v[rese[j][0]]+1, v[rese[j][1]]+1);
    rese[j][0] = rese[gene-i-1][0];
    rese[j][1] = rese[gene-i-1][1];
  }
}

int main(int argc, char **argv)
{
  char *bch;

  if (argc != 4) {
    fprintf(stderr, "Generator vstupu s mosty pro asfaltery.\nVolani: gen-1-connected <vrcholu> <hran> <komponent 2-souvislosti>\n");
    return 1;
  }

  n = strtol(argv[1], &bch, 0);
  if (*bch || n > MAXN || n < 1) {
    fprintf(stderr, "Spatny pocet vrcholu (1 <= n <= %d).\n", MAXN);
    return 1;
  }
  m = strtol(argv[2], &bch, 0);
  if (*bch || m > MAXM || m < n-1 || m > ((long long)n*(n-1)/2)) {
    fprintf(stderr, "Spatny pocet hran (n-1 <= m <= %d, (n,2)).\n", MAXM);
    return 1;
  }
  c = strtol(argv[3], &bch, 0);
  if (*bch || c < 1 || c > n/3) {
    fprintf(stderr, "Spatny pocet komponent 2-souvislosti (1 <= c <= n/3).\n");
    return 1;
  }
  generate();
  dump();
  return 0;
}
