#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAXN 100000
#define MAXM 500000

struct edge {
	int a,b;
};

int m,n;
struct edge e[MAXM];
int genm;

void gen_span(void)
{
	int i, a, b, j;
	char conv[MAXN];

	memset(conv, 0, n);
	conv[0] = 1;
	for (i = 1; i < n; i++) {
		a = random() % i;
		b = random() % (n-i);

		for (j = 0; a >= 0; j++)
			if (conv[j])
				a--;
		a = j-1;
		for (j = 0; b >= 0; j++)
			if (!conv[j])
				b--;
		b = j-1;
		conv[b] = 1;
		if (b < a) {
			j = a;
			a = b;
			b = j;
		}
		e[genm].a = a;
		e[genm++].b = b;
	}
	m -= n-1;
}

int have_edge(int a, int b)
{
	int i;

	for (i = 0; i < genm; i++)
		if (e[i].a == a && e[i].b == b)
			return 1;
	return 0;
}

void gen_rest(void)
{
	int a, b, i, j;

	for (i = 0; i < m; i++) {
restart:
		a = random() % n;
		b = random() % n;

		if (a == b)
			goto restart;
		if (b < a) {
			j = a;
			a = b;
			b = j;
		}
		if (have_edge(a, b))
			goto restart;
		e[genm].a = a;
		e[genm++].b = b;
	}
}

void gen_bigdeg(int c)
{
	int i, a, b, deg, j, k;
	char used[MAXN];

	memset(used, 0, n);
	for (i = 0; i < c; i++) {
		deg = n/4 + random() % (n/2);
		a = random() % (n-i);
		for (j = 0; a >= 0; j++)
			if (!used[j])
				a--;
		a = j-1;
		used[a] = 1;
		for (j = 0; j < deg; j++) {
restart:
			b = random() % n;
			if (a == b)
				goto restart;
			if (b < a) {
				k = a;
				a = b;
				b = k;
			}
			if (have_edge(a, b))
				continue;	/* Tady nerestartujeme - jinak se muzeme zacyklit...*/
			e[genm].a = a;
			e[genm++].b = b;
			m--;
		}
	}
}

void print_edges(void)
{
	int i, a;

	for (i = 0; i < genm; i++) {
		a = random() % (genm-i);
		if (a & 1)
			printf("%d %d\n", e[a].a+1, e[a].b+1);
		else
			printf("%d %d\n", e[a].b+1, e[a].a+1);
		e[a] = e[genm-i-1];
	}
}

int main(int argc, char **argv)
{
	int bdeg;

	if (argc != 4) {
		fprintf(stderr, "Usage: asfalter-gen <vertices> <edges> <big-degree-vertices>\n");
		return 1;
	}
	n = strtol(argv[1], NULL, 0);
	m = strtol(argv[2], NULL, 0);
	bdeg = strtol(argv[3], NULL, 0);
	if (m+1 < n) {
		fprintf(stderr, "Graph cannot be connected.\n");
		return 1;
	}
	if (m > n*(n-1)/2) {
		fprintf(stderr, "Too many edges.\n");
		return 1;
	}
	if (3*n/4*bdeg+n-1 > m) {
		fprintf(stderr, "Vertices with big degree would generate too many edges.\n");
		return 1;
	}
	printf("%d %d\n", n, m);
	gen_span();
	gen_bigdeg(bdeg);
	gen_rest();
	print_edges();

	return 0;
}
