program asfalter;
const
  INP = 'asfalt.in';
  OUT = 'asfalt.out';
  MAXN = 100000;
  MAXM = 500000;
type
  {Mezi kterymi vrcholy hrana vede a s kterou je sparovana (-1 pokud dosud neni)}
  edge = record
           a, b : Longint;
           pair : Longint;
        end;

  {Pocatek hran od daneho vrcholu v seznamu hran a stupen vrcholu}
  vertex = record
             start : Longint;
             deg : Longint;
             visited : Integer;
           end;

var
  et : Array[1..MAXM] of edge;		{Pole se vsemi hranami}
  ep : Array[1..2*MAXM] of Longint;	{Cisla hran serazena podle vrcholu, ke kterym patri}
  v : Array[1..MAXN] of vertex;		{Pole s vrcholy}
  vn, en : Longint;			{Pocet vrcholu a hran}

{Nacti vstup a vytvor reprezentaci grafu}
procedure read_input;
var
  i : Longint;
  FI, FO : Text;
begin
  Assign(FI, INP);
  Reset(FI);
  Read(FI, vn, en);
  {Otestujeme, jestli je uloha zjevne neresitelna}
  if en mod 2 = 1 then begin
    Assign(FO, OUT);
    Rewrite(FO);
    WriteLn(FO, 'Cesty nelze vyasfaltovat.');
    Close(FO);
    Close(FI);
    Halt;
  end;

  for i := 1 to vn do begin
    v[i].deg := 0;
    v[i].visited := 0;
  end;
  for i := 1 to en do begin
    Read(FI, et[i].a, et[i].b);
    et[i].pair := -1;
    Inc(v[et[i].a].deg);
    Inc(v[et[i].b].deg);
  end;
  Close(FI);
  {Seradime si pole s hranami}
  v[1].start := 1;
  for i := 2 to vn do begin
    v[i].start := v[i-1].start+v[i-1].deg;
    v[i-1].deg := 0;
  end;
  v[vn].deg := 0;
  for i := 1 to en do begin
    ep[v[et[i].a].start+v[et[i].a].deg] := i;
    Inc(v[et[i].a].deg);
    ep[v[et[i].b].start+v[et[i].b].deg] := i;
    Inc(v[et[i].b].deg);
  end;
end;

{Vrati druhy konec hrany}
function edge_end(v : Longint; edgenum : Longint) : Longint;
begin
  if et[edgenum].a <> v then
    edge_end := et[edgenum].a
  else
    edge_end := et[edgenum].b;
end;

{Vytiskne vysledek}
procedure print_out;
var
  i : Longint;
  O : Text;
  v : Array[1..4] of Longint;
  tmp : Longint;
begin
  Assign(O, OUT);
  Rewrite(O);
  for i := 1 to en do begin
    if et[i].pair > i then begin
      v[1] := et[i].a;
      v[2] := et[i].b;
      v[3] := et[et[i].pair].a;
      v[4] := et[et[i].pair].b;

      if (v[1] = v[3]) or (v[1] = v[4]) then begin
        tmp := v[1];
        v[1] := v[2];
        v[2] := tmp;
      end;
      if (v[4] = v[1]) or (v[4] = v[2]) then begin
        tmp := v[3];
        v[3] := v[4];
        v[4] := tmp;
      end;
      WriteLn(O, v[1],' ', v[2],' ', v[4]);
    end;
  end;
  Close(O);
end;

{Prohledavani do hloubky na parovani hran}
procedure DFS(act, parent : Longint);
var
  pair, i : Longint;
begin
  pair := -1;
  v[act].visited := 1;

  {Zavolame se na vsechny sousedni vrcholy, ve kterych jsme dosud nebyli}
  for i := v[act].start to v[act].start+v[act].deg-1 do
    if v[edge_end(act, ep[i])].visited = 0 then
      DFS(edge_end(act, ep[i]), act);

  {Nyni sparujeme zbyle hrany}
  for i := v[act].start to v[act].start+v[act].deg-1 do
    if (et[ep[i]].pair = -1) and (edge_end(act, ep[i]) <> parent) then begin
      if pair = -1 then
        pair := ep[i]
      else begin
        et[ep[i]].pair := pair;
        et[pair].pair := ep[i];
        pair := -1;
      end;
    end;

  if pair <> -1 then begin	{Hrana zbyla?}
    {Sparujeme ji s hranou k rodici}
    i := v[act].start;
    while edge_end(act, ep[i]) <> parent do
      Inc(i);
    et[ep[i]].pair := pair;
    et[pair].pair := ep[i];
  end;
end;

begin
  read_input;
  DFS(1,1);
  print_out;
end.
